#include <v8.h>
#include <node.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include "libstemmer/include/libstemmer.h"

using namespace v8;
using namespace node;

char * stem(char * word, int length) {
    static sb_stemmer * stemmer = sb_stemmer_new("en", NULL);
    return (char *) sb_stemmer_stem(stemmer, (const sb_symbol *) word, length);
}

Handle<Value> StemEn(const Arguments& args) {
    if (!args[0]->IsString())
        return Boolean::New(false);
    String::Utf8Value word(args[0]);
    return String::New((char *) stem(*word, word.length()));
}

extern "C" void init(Handle<Object> target) {
  HandleScope scope;
  NODE_SET_METHOD(target, "stem", StemEn);
}
